{
 Auf eine platte Linie reduzierte Form von D3DXLine9.
}




unit D3DXLine9;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, d3dx9, direct3d9;

type
 TD3DXLine9Point = packed record
  X,Y,Z : single;
  color : cardinal;
 end;
 TD3DXLine9PointExtra = packed record
  X,Y,Z : single;
  color : cardinal;
  used  : boolean;
 end;
 PD3DXLine9Point = ^TD3DXLine9Point;
 TD3DXLine9Points = array of TD3DXLine9Point;
 PD3DXLine9Points = ^TD3DXLine9Points;
 TD3DXLine9 = class
  private
   d3ddev9     : IDirect3DDevice9;
   bufferA     : IDirect3DVertexBuffer9;
   _Width      : single;
   LastBufSize : integer;
   procedure SetWidth(Width : single);
   function GetWidth : single;
  public
   Points     : TD3DXLine9Points;
   FirstPoint : TD3DXLine9PointExtra;
   LastPoint  : TD3DXLine9PointExtra;
   property Width : single read GetWidth write SetWidth;
   constructor Create(_d3ddev9 : IDirect3DDevice9);
   procedure Create3DLine;
   procedure Render;
   destructor Destroy; override;
 end;

implementation

const
 D3DFVF_TD3DLVertex = D3DFVF_XYZ or D3DFVF_DIFFUSE;

type
 TVertexbuffer = Array [0..1] of TD3DXLine9Point;
 PVertexbuffer = ^TVertexbuffer;

constructor TD3DXLine9.Create(_d3ddev9 : IDirect3DDevice9);
begin
 inherited Create;
 d3ddev9 := _d3ddev9;
 _Width := 0.01;
 SetLength(Points,0);
 if (d3ddev9.CreateVertexBuffer(0,D3DUSAGE_WRITEONLY,D3DFVF_TD3DLVertex,D3DPOOL_DEFAULT,BufferA,nil) <> D3D_OK) then exit;
 LastBufSize := 0;
 FirstPoint.Used := false;
 LastPoint.Used := false;
end;

procedure TD3DXLine9.SetWidth(Width : single);
begin
 _Width := Width / 2;
end;

function TD3DXLine9.GetWidth : single;
begin
 Result := _Width * 2;
end;

procedure TD3DXLine9.Create3DLine;
var
 pVerticesA : PVertexbuffer;
 Ux,Uy,
 Ox,Oy,
 Rx,Ry : single;
 _Ux,_Uy,
 _Ox,_Oy,
 _Rx,_Ry : single;
 cash    : single;
 h       : single;
 i       : integer;
begin
 if (Length(Points) = 0) then begin
  SetLength(Points,1);
  Points[0].Color := 0;
  Points[0].X := 0;
  Points[0].Y := 0;
  Points[0].Z := 0;
 end;
 if (LastBufSize <> Length(Points)) then begin
  BufferA := nil;
  if (d3ddev9.CreateVertexBuffer(sizeof(TD3DXLine9Point) * (Length(Points) * 2 + 2),D3DUSAGE_WRITEONLY,D3DFVF_TD3DLVertex,D3DPOOL_DEFAULT,BufferA,nil) <> D3D_OK) then exit;
 end;
 LastBufSize := Length(Points);
 if(BufferA.Lock(0,SizeOf(TD3DXLine9Point) * (Length(Points) * 2 + 2),pVerticesA,0) <> D3D_OK) then exit;

 if (FirstPoint.Used) then begin
  pVerticesA^[0].color := FirstPoint.color;
  pVerticesA^[0].X := FirstPoint.X;
  pVerticesA^[0].Y := FirstPoint.Y;
  pVerticesA^[0].Z := FirstPoint.Z;
 end else begin
  pVerticesA^[0].color := Points[0].color;
  pVerticesA^[0].X := Points[0].X;
  pVerticesA^[0].Y := Points[0].Y;
  pVerticesA^[0].Z := Points[0].Z;
 end;
 if (LastPoint.Used) then begin
  pVerticesA^[Length(Points) * 2 + 1].color := LastPoint.color;
  pVerticesA^[Length(Points) * 2 + 1].X := LastPoint.X;
  pVerticesA^[Length(Points) * 2 + 1].Y := LastPoint.Y;
  pVerticesA^[Length(Points) * 2 + 1].Z := LastPoint.Z;
 end else begin
  pVerticesA^[Length(Points) * 2 + 1].color := Points[Length(Points) - 1].color;
  pVerticesA^[Length(Points) * 2 + 1].X := Points[Length(Points) - 1].X;
  pVerticesA^[Length(Points) * 2 + 1].Y := Points[Length(Points) - 1].Y;
  pVerticesA^[Length(Points) * 2 + 1].Z := Points[Length(Points) - 1].Z;
 end;
 pVerticesA := pVerticesA + sizeof(TD3DXLine9Point);

 for i := 0 to Length(Points) - 1 do begin
  pVerticesA^[i * 2].color := Points[i].color;
  pVerticesA^[i * 2].Z := Points[i].Z;
  pVerticesA^[i * 2 + 1].color := Points[i].color;
  pVerticesA^[i * 2 + 1].Z := Points[i].Z;
  if (i < Length(Points) - 1) then begin
   Rx := Points[i + 1].X - Points[i].X;
   Ry := Points[i + 1].Y - Points[i].Y;
   h := sqrt(Rx * Rx + Ry * Ry);
   Ox := Points[i].X + _Width * Ry / h;
   Oy := Points[i].Y + _Width * Rx / h;
   Ux := Points[i].X - _Width * Ry / h;
   Uy := Points[i].Y - _Width * Rx / h;
   if (i = 0) or (Rx*_Ry = _Rx*Ry) then h := 0
   else h := (_Ux*_Ry + _Rx*(Uy-_Uy) - Ux*_Ry) / (Rx*_Ry-_Rx*Ry);
   pVerticesA^[i * 2].X := Ux + h * Rx;
   pVerticesA^[i * 2].Y := Uy + h * Ry;
   if (i = 0) or (Rx*_Ry = _Rx*Ry) then h := 0
   else h := (_Ox*_Ry + _Rx*(Oy-_Oy) - Ox*_Ry) / (Rx*_Ry-_Rx*Ry);
   pVerticesA^[i * 2 + 1].X := Ox + h * Rx;
   pVerticesA^[i * 2 + 1].Y := Oy + h * Ry;
   _Rx := Rx; _Ry := Ry;
   _Ox := Ox; _Oy := Oy;
   _Ux := Ux; _Uy := Uy;
  end else begin
   pVerticesA^[i * 2].Y := Points[i].Y;
   pVerticesA^[i * 2].X := Points[i].X;
   pVerticesA^[i * 2 + 1].Y := Points[i].Y;
   pVerticesA^[i * 2 + 1].X := Points[i].X;
  end;
 end;

 if (BufferA.Unlock <> D3D_OK) then exit;
end;

procedure TD3DXLine9.Render;
begin
 d3ddev9.SetStreamSource(0,BufferA,0,SizeOf(TD3DXLine9Point));
 d3ddev9.SetFVF(D3DFVF_TD3DLVertex);
 d3ddev9.DrawPrimitive(D3DPT_TRIANGLESTRIP,0,Length(Points) * 2 + 2);
end;

destructor TD3DXLine9.Destroy;
begin
 BufferA := nil;
 inherited;
end;

end.
