unit UnitControls; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, Settings;

type

  { TFormControls }

  TFormControls = class(TForm)
    Button1: TButton;
    Button2: TButton;
    EFullscreen: TEdit;
    EForward: TEdit;
    EBack: TEdit;
    ECenter: TEdit;
    ERot2: TEdit;
    ERot1: TEdit;
    ETop: TEdit;
    EBottom: TEdit;
    ERight: TEdit;
    ELeft: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure ButAbortClick(Sender: TObject);
    procedure ButOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RecKey(Sender: TObject);
    procedure SetKey(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
   _ContSet : TControlSettings;
   destructor Destroy; override;
  protected
   procedure DoClose(var CloseAction : TCloseAction); override;
  public
    { public declarations }
  end; 

var
  FormControls: TFormControls = nil;

implementation

{$R *.lfm}

{ TFormControls }

function KeyToStr(Key : Word) : AnsiString;
begin
 Result := IntToStr(Key);
end;

procedure TFormControls.FormShow(Sender: TObject);
begin
 _ContSet := ContSet;
 with (_ContSet) do begin
  EFullscreen.Text := KeyToStr(KFullscreen);
  EForward.Text := KeyToStr(KForward);
  EBack.Text := KeyToStr(KBack);
  ELeft.Text := KeyToStr(KLeft);
  ERight.Text := KeyToStr(KRight);
  ETop.Text := KeyToStr(KTop);
  EBottom.Text := KeyToStr(KBottom);
  ERot1.Text := KeyToStr(KRot1);
  ERot2.Text := KeyToStr(KRot2);
  ECenter.Text := KeyToStr(KCenter);
 end;
end;

procedure TFormControls.SetKey(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 with (TEdit(Sender)) do begin
  if (Color <> $A0FFA0) then exit;
  Text := KeyToStr(Key);
  Color := $FFFFFF;
 end;
 with (_ContSet) do begin
  if (Sender = EFullscreen) then KFullscreen := Key;
  if (Sender = EForward) then KForward := Key;
  if (Sender = EBack) then KBack := Key;
  if (Sender = ELeft) then KLeft := Key;
  if (Sender = ERight) then KRight := Key;
  if (Sender = ETop) then KTop := Key;
  if (Sender = EBottom) then KBottom := Key;
  if (Sender = ERot1) then KRot1 := Key;
  if (Sender = ERot2) then KRot2 := Key;
  if (Sender = ECenter) then KCenter := Key;
 end;
end;

procedure TFormControls.RecKey(Sender: TObject);
var i : integer;
begin
 for i := 0 to Self.ControlCount-1 do if (Self.Controls[i] is TEdit) then TEdit(Self.Controls[i]).Color := $FFFFFF;
 TEdit(Sender).Color := $A0FFA0;
end;

procedure TFormControls.ButOKClick(Sender: TObject);
begin
 ContSet := _ContSet;
 SaveSettingsNow;
 Close;
end;

procedure TFormControls.ButAbortClick(Sender: TObject);
begin
 Close;
end;

procedure TFormControls.DoClose(var CloseAction : TCloseAction);
begin
 CloseAction := caFree;
end;

destructor TFormControls.Destroy;
begin
 FormControls := nil;
 inherited;
end;

end.

