unit UnitSources; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  WaveSimulation, stdctrls, extctrls;

type

  TFourierBox = record
   panel : TPanel;
   edit  : TEdit;
   text  : TLabel;
   But   : TButton;
  end;

  TFormSources = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure MapLoad;
    procedure SetFourier(Sender : TObject);
  private
    panels : Array of TFourierBox;
  public
    { public declarations }
  end; 

var
  FormSources: TFormSources;

implementation

{$R *.lfm}

{ TFormSources }

procedure TFormSources.FormShow(Sender: TObject);
begin
 Sim.OnMapLoad := @MapLoad;
 MapLoad;
end;

procedure TFormSources.MapLoad;
var i,j : integer;
begin
 self.DestroyComponents;
 SetLength(panels,Length(Sim.Sources));
 for i := 0 to Length(panels) - 1 do with (Panels[i]) do begin
  Panel := TPanel.create(self);
  Panel.Parent := self;
  Panel.Left := 0;
  Panel.Height := 50;
  Panel.Top := i * Panel.Height;
  Panel.AnchorParallel(akRight,0,self);

  Text := TLabel.Create(self);
  Text.Parent := Panel;
  Text.Top := 2;
  Text.Left := 2;
  case (Sim.Sources[i].Art) of
   srcLaser : Text.Caption := 'Quelle ' + inttostr(i+1) + '   Typ: Laser';
   srcCenter : Text.Caption := 'Quelle ' + inttostr(i+1) + '   Typ: Zentral';
   else Text.Caption := 'Quelle ' + inttostr(i+1) + '   Typ: Unbekannt';
  end;

  Edit := TEdit.Create(self);
  Edit.Parent := Panel;
  Edit.Top := 20;
  Edit.Left := 2;
  Edit.AnchorParallel(akRight,60,Panel);
  for j := 0 to Length(Sim.Sources[i].Fourier)-1 do begin
   if (Edit.Text <> '') then Edit.Text := Edit.Text + ' + ';
   Edit.Text := Edit.Text + IntToStr(Sim.Sources[i].Fourier[j].Amp) + ' * sin(t / ' + inttostr(Sim.Sources[i].Fourier[j].Long) + ' + ' + IntToStr(Sim.Sources[i].Fourier[j].Phi0) + ')';
  end;

  But := TButton.Create(self);
  But.Parent := Panel;
  But.Top := 20;
  But.Left := Panel.Width - 58;
  But.Width := 56;
  But.Height := Edit.Height;
  But.Caption := 'OK';
  But.onClick := @SetFourier;
 end;
end;

procedure TFormSources.SetFourier(Sender : TObject);
var
 i,j  : integer;
 b    : byte;
 s    : ansiString;
 edit : TEdit;
 Amp  : word;
 Long : Byte;
 Phi0 : Word;
 Fourier : Array of TFourierPart;
begin
 for j := 0 to Length(Panels)-1 do if (Panels[j].But = Sender) then break;
 if (Length(Panels) = 0) or (Panels[j].But <> Sender) then exit;
 edit := Panels[j].Edit;
 s := '';
 b := 0;
 for i := 1 to Length(edit.Text) do case (b) of
  0 : begin
   if (edit.Text[i] = '*') then begin
    try
     Amp := StrToInt(s);
     s := '';
     inc(b);
    except
     Edit.Color := clRed;
     exit;
    end;
   end else if (edit.Text[i] <> ' ') then s := s + edit.Text[i];
  end;
  1 : begin
   if (edit.Text[i] = '/') then begin
    if (s <> 'sin(t') then begin Edit.Color := clRed; exit; end;
    s := '';
    inc(b);
   end else if (edit.Text[i] <> ' ') then s := s + edit.Text[i];
  end;
  2 : begin
   if (edit.Text[i] = '+') then begin
    try
     Long := StrToInt(s);
     s := '';
     inc(b);
    except
     Edit.Color := clRed;
     exit;
    end;
   end else if (edit.Text[i] <> ' ') then s := s + edit.Text[i];
  end;
  3 : begin
   if (edit.Text[i] = ')') then begin
    try
     Phi0 := StrToInt(s);
     s := '';
     inc(b);
    except
     Edit.Color := clRed;
     exit;
    end;
    SetLength(Fourier,Length(Fourier)+1);
    Fourier[Length(Fourier)-1].Amp := Amp;
    Fourier[Length(Fourier)-1].Long := Long;
    Fourier[Length(Fourier)-1].Phi0 := Phi0;
    Fourier[Length(Fourier)-1].Phi := 0;
   end else if (edit.Text[i] <> ' ') then s := s + edit.Text[i];
  end;
  4 : begin
   if (edit.Text[i] = '+') then begin
    if (s <> '') then begin Edit.Color := clRed; exit; end;
    s := '';
    b := 0;
   end else if (edit.Text[i] <> ' ') then s := s + edit.Text[i];
  end;
 end;
 Edit.Color := clWhite;
 Sim.Sources[j].Fourier := Fourier;
end;

end.

